import { world, system, ItemStack } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
function Vector(x, y, z){
  let Vector = {
      x: x,
      y: y,
      z: z
  }
  return Vector 
}
world.afterEvents.itemUse.subscribe(data => {
    if (data.itemStack.typeId == "blayy:builder_wand" && data.source.isSneaking == true) {
let mode = new ActionFormData()
mode.title("Select Mode")
mode.button("§0<- Outline Shape ->", "textures/cwui/os")
mode.button("§0<- Ground ->", "textures/cwui/g")
mode.button("§0<- Outline Side XZ ->", "textures/cwui/os2")
mode.button("§0<- Perpendicular Sides ->", "textures/cwui/ps")
mode.button("§0<- Circular Sides ->", "textures/cwui/cs")
mode.button("§0<- Hollow Sphere ->", "textures/cwui/hs")

mode.show(data.source).then(resp => {
    let eq = data.source.getComponent("equippable")
if (resp.selection == 2) {

    system.run(() => {
        eq.getEquipmentSlot("Mainhand").setLore([`Outline Side XZ`])
    
    })
    }
    else if (resp.selection == 1) {
    
        system.run(() => {  
            eq.getEquipmentSlot("Mainhand").setLore([`Ground`])
        
        })
        }
        else if (resp.selection == 0) {
           
            system.run(() => {
                eq.getEquipmentSlot("Mainhand").setLore([`Outline Shape`])
            
            })
            }
            if (resp.selection == 3) {

                system.run(() => {
                    eq.getEquipmentSlot("Mainhand").setLore([`Perpendicular Structures`])
                
                })
                }
                if (resp.selection == 4) {

                    system.run(() => {
                        eq.getEquipmentSlot("Mainhand").setLore([`Circular Sides`])
                    
                    })
                    }
                    if (resp.selection == 5) {

                        system.run(() => {
                            eq.getEquipmentSlot("Mainhand").setLore([`Hollow Sphere`])
                        
                        })
                        }
})
    }
})
let once = 0
world.beforeEvents.itemUseOn.subscribe(data => {
    
        let player = data.source
        
           
            if (data.itemStack.typeId == "blayy:builder_wand" && data.itemStack.getLore()[0]) {
                let loc = data.block.location
               
                let eq = data.source.getComponent("equippable")
               
                if (data.itemStack.getLore()[1]) {
                   let cords = data.itemStack.getLore()[1]
                   let vec1 = new Vector(parseInt(cords.split(" ")[0]), parseInt(cords.split(" ")[1]), parseInt(cords.split(" ")[2]))
                   let vec2 = new Vector(loc.x, loc.y+1, loc.z)
             
           let blockId = `${cords.split(" ")[3]}`
           let ainv = 0
           let bq = 0
           let onc = 1
           if (data.itemStack.getLore()[0] == "Outline Side XZ") {
               for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                   for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {
               
                       if (ix === vec1.x || ix === vec2.x || iz === vec1.z || iz === vec2.z) {
                           if (player.dimension.getBlock({x: ix, y: vec1.y, z: iz})?.getItemStack()?.typeId) {
           
                           }else {
                               system.run(() => {
                                   player.runCommand(`particle minecraft:villager_happy ${ix} ${vec1.y} ${iz}`); 
                               })
                               bq++
                           }
                       }
                   }
               }
           }
           if (data.itemStack.getLore()[0] == "Ground") {
               for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                   for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {       
                       if (player.dimension.getBlock({x: ix, y: vec1.y, z: iz})?.getItemStack()?.typeId) {
           
                       }else {
                           system.run(() => {
                               player.runCommand(`particle minecraft:villager_happy ${ix} ${vec1.y} ${iz}`); 
                           })
                          
                           bq++
                       }
                   }
               }
           }
           const minX = Math.min(vec1.x, vec2.x);
           const maxX = Math.max(vec1.x, vec2.x);
           const minY = Math.min(vec1.y, vec2.y);
           const maxY = Math.max(vec1.y, vec2.y);
           const minZ = Math.min(vec1.z, vec2.z);
           const maxZ = Math.max(vec1.z, vec2.z);
           
           if (data.itemStack.getLore()[0] == "Outline Shape") {
               
           
               
               for (let x = minX; x <= maxX; x++) {
                   for (let y = minY; y <= maxY; y++) {
                       for (let z = minZ; z <= maxZ; z++) {
                          
                           if (x === minX || x === maxX || y === minY || y === maxY || z === minZ || z === maxZ) {
                               if (player.dimension.getBlock({x: x, y: y, z: z})?.getItemStack()?.typeId) {
           
                               }else {
                                   system.run(() => {
                                       player.runCommand(`particle minecraft:villager_happy ${x} ${y} ${z}`); 
                                   })
                                  
                                   bq++
                               }
                               
                 
                           }
                       }
                   }
               }
           }
           let rd;
           if (Math.abs(vec1.x - vec2.x) != 0) {
               rd = Math.abs(vec1.x - vec2.x)
           }else{
               rd = Math.abs(vec1.z - vec2.z)
           }
           const centerX = vec1.x;
               const centerY = vec1.y;
               const centerZ = vec1.z;
               let radius;
           if (data.itemStack.getLore()[0] == "Perpendicular Structures") {
               const usedCoordinates = new Set();
              
               radius = rd;
              
               for (let y = centerY - radius; y <= centerY + radius; y++) {
                   
                   for (let angle = 0; angle <= 360; angle += 5) {
                       const radians = angle * (Math.PI / 180);
                       const x = Math.round(centerX + radius * Math.cos(radians));
                       const z = Math.round(centerZ + radius * Math.sin(radians));
                       const coordinateKey = `${Math.round(x)},${Math.round(z)}`;
                   
                       if (Math.abs(x - centerX) === radius || Math.abs(z - centerZ) === radius) {
                        
                           
                           if (player.dimension.getBlock({x: x, y: centerY, z: z})?.getItemStack()?.typeId) {
                               if (!usedCoordinates.has(coordinateKey)) {
                                   usedCoordinates.add(coordinateKey)
                               bq++
                               }
                           }else {
                            
                          
                               system.run(() => {
                                   player.runCommand(`particle minecraft:villager_happy ${x} ${y} ${z}`); 
                                  
                               })
                           
                           
                           }
                           }
                       
                   }
               }
              bq = ((rd + 1) * (rd + 1)) * 4 - bq
           }
           if (data.itemStack.getLore()[0] == "Circular Sides") {
              const centerY = vec1.y; 
               const centerX = vec1.x; 
               const centerZ = vec1.z;
               radius = rd;  
               const usedCoordinates = new Set();
               for (let angle = 0; angle <= 360; angle += 1) {
                   const radians = angle * (Math.PI / 180);
                   const x = Math.round(centerX + radius * Math.cos(radians));
                   const z = Math.round(centerZ + radius * Math.sin(radians));
               
            
                   const coordinateKey = `${Math.round(x)},${Math.round(z)}`;
                   if (!usedCoordinates.has(coordinateKey)) {
                       usedCoordinates.add(coordinateKey); 
                   
               
                  
                   if (player.dimension.getBlock({x: x, y: centerY, z: z})?.getItemStack()?.typeId) {
                           
                   }else {
           bq++
                       system.run(() => {
                           player.runCommand(`particle minecraft:villager_happy ${x} ${centerY} ${z}`); 
                         
                 
                          
                       })
           
                      
                   }
               } 
               }
                 
           }
           if (data.itemStack.getLore()[0] == "Hollow Sphere") {
               function createHollowSphere1(centerX, centerY, centerZ, radius) {
                   const diameter = radius * 2;
                   const minX = centerX - radius;
                   const minY = centerY - radius;
                   const minZ = centerZ - radius;
                   const maxX = centerX + radius;
                   const maxY = centerY + radius;
                   const maxZ = centerZ + radius;
                   const usedCoordinates = new Set();
                   for (let x = minX; x <= maxX; x++) {
                       for (let y = minY; y <= maxY; y++) {
                           for (let z = minZ; z <= maxZ; z++) {
                               const distance = Math.sqrt((x - centerX) ** 2 + (y - centerY) ** 2 + (z - centerZ) ** 2);
                            
                               const coordinateKey = `${Math.round(x)},${Math.round(z)}`;
                               if (distance >= radius - 0.5 && distance <= radius + 0.5) {
                                 
                               
                                       
                                  
                                   if (player.dimension.getBlock({x: x, y: y, z: z})?.getItemStack()?.typeId) {
                           
                                   }else {
                                       bq++
                                       system.run(() => {
                                           player.runCommand(`particle minecraft:villager_happy ${x} ${y} ${z}`); 
                                         
                                 
                                          
                                       })
                           
                                      
                                   }
                               
                           }
                           }
                       }
                   }
               }
           
               const sphereCenterX = vec1.x;
               const sphereCenterY = vec1.y;
               const sphereCenterZ = vec1.z;
               const sphereRadius = rd;
               createHollowSphere1(sphereCenterX, sphereCenterY, sphereCenterZ, sphereRadius);
               
           }
           for (let i = 0; i < 35; i++) {
               const item = data.source.getComponent("inventory").container.getItem(i);
               if (item?.typeId == blockId) {
                   ainv += item.amount
               }
             
               };
           let confirm = new ActionFormData()
           confirm.button("text.confirm")
           confirm.body({rawtext: [{translate: "bw.qe"}, {text: `${bq}`},  {translate: `bw.b`}, {text: `\n`},{translate: "bw.vp"}, {text: `${ainv}`},  {translate: `bw.b`}, {text: `\n`},  {translate: `bw.aveso`}]})
           system.runTimeout(() => {
            
               confirm.show(player).then(resp => {
                   if (resp.selection == 0) {
                       if (data.itemStack.getLore()[0] == "Outline Shape") {
                       for (let x = minX; x <= maxX; x++) {
                           for (let y = minY; y <= maxY; y++) {
                               for (let z = minZ; z <= maxZ; z++) {
                                   onc++
                                   system.runTimeout(() => {
                                       if (x === minX || x === maxX || y === minY || y === maxY || z === minZ || z === maxZ) {
                                   player.runCommand(`particle blayy:wand ${x} ${y} ${z}`); 
                                       }  
                                   }, onc)
                                   system.runTimeout(() => {
                                   if (x === minX || x === maxX || y === minY || y === maxY || z === minZ || z === maxZ) {
                                     
                                       player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                       player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);      
                                     
                                       player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);      
                                      
                                   }
                               }, onc)    
                               }
                           }
                       }
                     }
                     if (data.itemStack.getLore()[0] == "Ground") {
                     
                       for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                           for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) { 
                               onc++      
                               system.runTimeout(() => {
                                   player.runCommand(`particle blayy:wand ${ix} ${vec1.y} ${iz}`); 
                               player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run clear @s ${blockId} 0 1`);
                               player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run setblock ${ix} ${vec1.y} ${iz} ${blockId}`);       
                           }, onc)      
                           }
                       }
                   }
                   if (data.itemStack.getLore()[0] == "Outline Side XZ") {
                       for (let ix = Math.min(vec1.x, vec2.x); ix <= Math.max(vec1.x, vec2.x); ix++) {
                           for (let iz = Math.min(vec1.z, vec2.z); iz <= Math.max(vec1.z, vec2.z); iz++) {
                               onc++  
                               system.runTimeout(() => {
                                   player.runCommand(`particle blayy:wand ${ix} ${vec1.y} ${iz}`); 
                               if (ix === vec1.x || ix === vec2.x || iz === vec1.z || iz === vec2.z) {
                                    
                                   player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run clear @s ${blockId} 0 1`);
                                   player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${ix} ${vec1.y} ${iz} air run setblock ${ix} ${vec1.y} ${iz} ${blockId}`);           
                               }
                           }, onc)     
                           }
                       }
                   }
                   
                
                    if (data.itemStack.getLore()[0] == "Perpendicular Structures") {
                     
                       const centerX = vec1.x;
                       const centerY = vec1.y;
                       const centerZ = vec1.z;
                       const radius = rd;
                 
                       for (let y = centerY - radius; y <= centerY + radius; y++) {
                           for (let angle = 0; angle <= 360; angle += 5) {
                               const radians = angle * (Math.PI / 180);
                               const x = Math.round(centerX + radius * Math.cos(radians));
                               const z = Math.round(centerZ + radius * Math.sin(radians));
                      
                       
                               if (Math.abs(x - centerX) === radius || Math.abs(z - centerZ) === radius) {
                                   player.runCommand(`particle blayy:wand ${x} ${y} ${z}`); 
                                   player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                       player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);      
                                     
                                       player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);      
                               }
                           
                           }
                       }
                       
                       
                   }
                   if (data.itemStack.getLore()[0] == "Circular Sides") {
                       const centerX = vec1.x;
                       const centerY = vec1.y;
                       const centerZ = vec1.z;
                       const radius = rd;
               
                       
                       for (let angle = 0; angle <= 360; angle += 1) {
                           const radians = angle * (Math.PI / 180);
                           const x = Math.round(centerX + radius * Math.cos(radians));
                           const z = Math.round(centerZ + radius * Math.sin(radians));
                       
                      
                      
                               onc++;
                       
                               system.runTimeout(() => {
                                   player.runCommand(`particle blayy:wand ${x} ${centerY} ${z}`);
                                   player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${centerY} ${z} air run clear @s ${blockId} 0 1`);
                                   player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${centerY} ${z} air run setblock ${x} ${centerY} ${z} ${blockId}`);
                                   player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${centerY} ${z}`);
                               }, onc/8);
                           
                       }
                       
                   }
                   if (data.itemStack.getLore()[0] == "Hollow Sphere") {
                       function createHollowSphere(centerX, centerY, centerZ, radius) {
                           const diameter = radius * 2;
                           const minX = centerX - radius;
                           const minY = centerY - radius;
                           const minZ = centerZ - radius;
                           const maxX = centerX + radius;
                           const maxY = centerY + radius;
                           const maxZ = centerZ + radius;
                       
                           for (let x = minX; x <= maxX; x++) {
                               for (let y = minY; y <= maxY; y++) {
                                   for (let z = minZ; z <= maxZ; z++) {
                                       const distance = Math.sqrt((x - centerX) ** 2 + (y - centerY) ** 2 + (z - centerZ) ** 2);
                                       if (distance >= radius - 0.5 && distance <= radius + 0.5) {
                                           
                               onc++;
                       
                               system.runTimeout(() => {
                                           player.runCommand(`particle blayy:wand ${x} ${y} ${z}`); 
                                           player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run clear @s ${blockId} 0 1`);
                                           player.runCommand(`execute if entity @s[hasitem={item=${blockId}}] if block ${x} ${y} ${z} air run setblock ${x} ${y} ${z} ${blockId}`);      
                                         
                                           player.runCommand(`execute unless entity @s[hasitem={item=${blockId}}] run particle minecraft:villager_angry ${x} ${y} ${z}`);      
                                       }, onc/2);
                                       }
                                   }
                               }
                           }
                       }
                   
                       const sphereCenterX = vec1.x;
                       const sphereCenterY = vec1.y;
                       const sphereCenterZ = vec1.z;
                       const sphereRadius = rd;
                       createHollowSphere(sphereCenterX, sphereCenterY, sphereCenterZ, sphereRadius);
                       
                   }
                   }
                   })
           })
           system.run(() => {
               eq.getEquipmentSlot("Mainhand").setLore([`${data.itemStack.getLore()[0]}`])
           })
                }else if (data.source.isSneaking == false) {
                   system.run(() => {
                       eq.getEquipmentSlot("Mainhand").setLore([`${data.itemStack.getLore()[0]}`,`${data.block.location.x} ${data.block.location.y} ${data.block.location.z} ${data.block.getItemStack().typeId}`])
                   })
                
                 
                }
           
             }
      
            
        
 

})